/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// WhatsAppTemplateButtonType the model 'WhatsAppTemplateButtonType'
type WhatsAppTemplateButtonType string

// List of WhatsAppTemplateButtonType
const (
	WhatsAppTemplateButtonTypePhoneNumber WhatsAppTemplateButtonType = "PHONE_NUMBER"
	WhatsAppTemplateButtonTypeUrl WhatsAppTemplateButtonType = "URL"
	WhatsAppTemplateButtonTypeQuickReply WhatsAppTemplateButtonType = "QUICK_REPLY"
)

// All allowed values of WhatsAppTemplateButtonType enum
var AllowedWhatsAppTemplateButtonTypeEnumValues = []WhatsAppTemplateButtonType{
	"PHONE_NUMBER",
	"URL",
	"QUICK_REPLY",
}

func (v *WhatsAppTemplateButtonType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := WhatsAppTemplateButtonType(value)
	for _, existing := range AllowedWhatsAppTemplateButtonTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid WhatsAppTemplateButtonType", value)
}

// NewWhatsAppTemplateButtonTypeFromValue returns a pointer to a valid WhatsAppTemplateButtonType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewWhatsAppTemplateButtonTypeFromValue(v string) (*WhatsAppTemplateButtonType, error) {
	ev := WhatsAppTemplateButtonType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for WhatsAppTemplateButtonType: valid values are %v", v, AllowedWhatsAppTemplateButtonTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v WhatsAppTemplateButtonType) IsValid() bool {
	for _, existing := range AllowedWhatsAppTemplateButtonTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to WhatsAppTemplateButtonType value
func (v WhatsAppTemplateButtonType) Ptr() *WhatsAppTemplateButtonType {
	return &v
}

type NullableWhatsAppTemplateButtonType struct {
	value *WhatsAppTemplateButtonType
	isSet bool
}

func (v NullableWhatsAppTemplateButtonType) Get() *WhatsAppTemplateButtonType {
	return v.value
}

func (v *NullableWhatsAppTemplateButtonType) Set(val *WhatsAppTemplateButtonType) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateButtonType) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateButtonType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateButtonType(val *WhatsAppTemplateButtonType) *NullableWhatsAppTemplateButtonType {
	return &NullableWhatsAppTemplateButtonType{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateButtonType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateButtonType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

